<?php
// class.khattxt.php v1.0 25/05/2003 kyex


// MANQUE: nettoyage fichier, enteteHTML

include_once XOOPS_ROOT_PATH."/modules/khat/class/class.khat.php";


/**
* class KhatTxt(Khat)
*
* Chat avec stockage dans un fichier texte
*
*/
class KhatTxt extends Khat
{

    /**
    * KhatTxt::KhatTxt()
    *
    * { Description }
    *
    * @param integer $id
    */
    function KhatTxt($id=0)
	{
	$this->filename = XOOPS_ROOT_PATH."/modules/khat/cache/msg.php";
	//$this->soundfile = XOOPS_ROOT_PATH."/modules/khat/msg.wav";
   	//	$this->db =& Database::getInstance();
		if ( is_array($id) ) {
			$this->makeKhat($id);
		}
	}
/**
* private
*
* Renvoie l'interpretation en HTML de la ligne passe en parametre
*
* @param string $s ligne  afficher
* @param int $i numero de la ligne
* @return string ligne en HTML pour affichage
*/
    function AfficheLigne($s, $i)
    {
        $myts =& MyTextSanitizer::getInstance();
        if($s=="" || $s=="<?php exit; ?".">")
        {
            return "";
        }
        // traitement de l'heure
        $heure = formatTimestamp(substr($s,0,10),$this->formatdate);
        $s="<b>".$heure." ".substr($s,10);
        // kyex 21/05/2003 pour v1.1 - et myts xoops2
        if($this->html==1)
             $s = $myts->undoHtmlSpecialChars($s);
        $s=$myts->displayTarea($s,1,$this->smiley,$this->xoopscode);

        return $this->liensAdmin($i).$s."<br />";
    }
    
    function getMessage($s)
    {
        if($s=="" || $s=="<?php exit; ?".">")
        {
            return "";
        }
        return substr($s, strpos($s,"</b>") + 4);        ;
    }
    
    function getUser($s)
    {
        if($s=="" || $s=="<?php exit; ?".">")
        {
            return "";
        }
        $s=substr($s,13,strpos($s,"</i>")-13);
        return $s;
        
    }
    
    function getUid($s)
    {
        if($s=="" || $s=="<?php exit; ?".">")
        {
            return 0;
        }
        $db =& Database::getInstance();
        $s=$this->getUser($s);
        $sql = "SELECT uid FROM ".$db->prefix("users")." WHERE uname='$s'";
        $res = $db->query($sql);
        if($res==0) return 0;
        $row = $db->fetchArray($res);
        return $row["uid"];
        
    }
    
    function getHeure($s)
    {
        if($s=="" || $s=="<?php exit; ?".">")
        {
            return "";
        }
        return substr($s,0,10);
    }

    
/**
* public
*
* Donne le contenu des $length dernieres lignes
*
* @param $length Nombre de ligne  lire pour affichage
* @return string le contenu du chat en HTML
*/
    function getAllLines($length=5){
	    $content="";
	    $lines=file($this->filename);
	    $a=count($lines);
	    $u=$a-$length;
	    if($u<0) $u=0;
	    if($this->nouveauxmsg=="bas")
	    {
            for($i =$u ;$i<$a; $i++)
            {
                $content .= $this->AfficheLigne(rtrim($lines[$i]),$i);
            }
	    }
	    else
	    {
            for($i = $a-1; $i >= $u ;$i--)
            {
                $content .= $this->AfficheLigne(rtrim($lines[$i]),$i);
            }
		}
        return $content;
	}

/**
* public
*
* Donne l'heure du dernier message envoy qui correspondat  la date de modification du fichier
*
* @return int date du dernier message
*/
        function lastMessageDate()
    {
        return filemtime($this->filename);
    }

/**
* public
*
* Sauvagarde du message dans le fichier
*
*/
        function store() {
		$myts =& MyTextSanitizer::getInstance();
        $message=$this->message;
        //$message=$myts->makeTareaData4Save($message,0);
        $message=$myts->htmlSpecialChars($message);
        $message=$myts->stripSlashesGPC($message);
        if ($message != "")
        {
            // ecriture de l'heure au format time unix standard pour Xoops
            $infos = time()."<i>".$this->getPersonString()."</i>";
            $fp = fopen($this->filename, "a+");
            $fw = fwrite($fp, "\n$infos :</b> $message");
            fclose($fp);
        }
        $this->nettoyage();
	}

/**
* KhatSql::nettoyage()
*
* Supprime de la base les lignes trop ancienne
*
*/
    function nettoyage()
    {
	    $lignes=file($this->filename);
	    $nblignes=count($lignes);
		if($nblignes>$this->maxlignes)
		{
		    // on garde les dernieres lignes => on recupere la date de la premiere ligne a garder
            $premiereligne = $nblignes-$this->minlignes;
            $deleted = unlink($this->filename);
            $fp = fopen($this->filename, "w");
            fwrite($fp, "<?php exit; ?".">\n");
            for($i = $premiereligne; $i< $nblignes ;$i++)
            {
                fwrite($fp, $lignes[$i]);
            }
            fclose($fp);
        }
	}

/**
* KhatSql::supplig()
*
* Supprime ddu fichier une ligne (censure)
*
*/
    function supplig($lig)
    {
	    global $xoopsUser;
	    $s="";
	    //$s.= "supplig $lig<br>";
    	if($xoopsUser)
		{
		    //$s.= "user!";
		    $xoopsKhatModule = XoopsModule::getByDirname("khat");
            if ( $xoopsUser->isAdmin($xoopsKhatModule->mid()))
            {
                // on a le droit de virer la ligne $lig
                $s .="on supprime<br>";
                $lignes=file($this->filename);
                $nblignes=count($lignes);
                // on garde les dernieres lignes => on recupere la date de la premiere ligne a garder
                $deleted = unlink($this->filename);
                $fp = fopen($this->filename, "w");
                for($i = 0; $i< $lig ;$i++)
                {
                    fwrite($fp, $lignes[$i]);
                }
                for($i = $lig+1; $i< $nblignes ;$i++)
                {
                    fwrite($fp, $lignes[$i]);
                }
                fclose($fp);

            }
        }
        return $s;
    }
    function search($queryarray, $andor, $limit, $offset, $userid)
    {
        $lignes=file($this->filename);
        $ret = array();
        $nblignes=count($lignes);
        $i=0;
        foreach ($lignes as $num => $ligne)
        {
            if (stristr($ligne, $queryarray[0]))
            {
                $ret[$i]['link'] = "index.php?op=archive&lig=".$num."";
                $ret[$i]['title'] = $this->getMessage($ligne);
                $ret[$i]['time'] = $this->getHeure($ligne);
                $ret[$i]['uid'] = $this->getUid($ligne);
                $i++;
            }
        }
        return $ret;
    }


}
?>
